#ifndef APPLICATION_H
#define APPLICATION_H

#include <vector>
#include <map>

#include "complex.h"
#include "gl_viewer.h"

struct rectangle
{
public:
    rectangle(){}
    
    rectangle(float x0, float y0, float x1, float y1)
        : x0(x0), y0(y0), x1(x1), y1(y1) {}

    void set(float x0, float y0, float x1, float y1)
    {
        this->x0 = x0; this->y0 = y0; this->x1 = x1; this->y1 = y1;
    }

    float x0, y0;
    float x1, y1;
};

class application : public gl_viewer
{
public:
    application();
    ~application();
    void init_event();
    void draw_event();
    void mouse_click_event(
        mouse_button button, mouse_button_state button_state, 
        int x, int y
    );
    void mouse_move_event(
        int x, int y
    );
    void keyboard_event(unsigned char key, int x, int y);

private:
    enum mode { RENDER, SELECTION };

    //computes the viewing window for your complex plane
    complex_number viewport_to_complex_plane(
        int x, int y);

    //stores all viewing windows that have been made
    std::vector<rectangle> zoom_history;

    int niter;

    // holds the boundary of the imaginary plane that is rendered to viewport
    rectangle cb;
    rectangle cb_new;

    //used for maintaining how many points have been stored
    mode md;

    // selection mode box
    rectangle sb;
    char *img;
}; 

#endif
